DROP TABLE IF EXISTS `config`;
CREATE TABLE `config` (
  `title` varchar(200) NOT NULL,
  `email` varchar(100) default NULL,
  `ices` varchar(50) default NULL,
  `library` varchar(200) default NULL,
  PRIMARY KEY  (`title`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


DROP TABLE IF EXISTS `media`;
CREATE TABLE `media` (
  `id` int(10) NOT NULL auto_increment,
  `files` varchar(500) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=129 DEFAULT CHARSET=latin1;

DROP TABLE IF EXISTS `members`;
CREATE TABLE `members` (
  `user_id` int(4) NOT NULL auto_increment,
  `username` varchar(65) NOT NULL default '',
  `password` varchar(65) NOT NULL default '',
  `fname` varchar(25) default NULL,
  `lname` varchar(25) default NULL,
  `email` varchar(75) default NULL,
  `access` int(11) default NULL,
  PRIMARY KEY  (`user_id`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `playlist`;
CREATE TABLE `playlist` (
  `id` int(11) NOT NULL auto_increment,
  `file` varchar(200) NOT NULL,
  `uid` int(11) NOT NULL,
  `name` varchar(200) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=latin1;

DROP TABLE IF EXISTS `playlist_content`;
CREATE TABLE `playlist_content` (
  `id` int(11) NOT NULL auto_increment,
  `fid` int(11) NOT NULL,
  `pid` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=23 DEFAULT CHARSET=latin1;


ALTER TABLE servers ADD autodj int(11) NOT NULL default '0';
ALTER TABLE servers ADD Playlist int(11) default NULL;
ALTER Table servers ADD random tinyint(4) NOT NULL default '0';
