ALTER TABLE servers ADD maxbitrate int(4);
CREATE TABLE `smi` (
        `ver_id` tinyint(1) UNSIGNED NOT NULL,
        `version` varchar(10) NOT NULL,
        PRIMARY KEY (`ver_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Inserting data for table `smi`
--

LOCK TABLES `smi` WRITE;
/*!40000 ALTER TABLE `smi` DISABLE KEYS */;
INSERT INTO `smi` VALUES(1,'0.3.3');
UNLOCK TABLES;

--
-- Table structure for table `config`
--

DROP TABLE IF EXISTS `config`;
CREATE TABLE `config` (
  `id` int(11) NOT NULL auto_increment,
  `setting` varchar(100) NOT NULL,
  `value` varchar(255) NOT NULL,
  `title` varchar(255) default NULL,
  `groupid` int(5) NOT NULL default '1',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Data for table `config`
--

LOCK TABLES `config` WRITE;
/*!40000 ALTER TABLE `config` DISABLE KEYS */;
  INSERT INTO `config` VALUES (1,'site_title','SHOUTcast Management Interface','Site title',1),(2,'web_addr','http://localhost/smi','Site URL',1),(3,'adm_email','yourmail@yourdomain.tld','Admin e-mail',1),(4,'smi_path','/var/www/html/smi','Path to SMI',1),(5,'host_addr','127.0.0.1','Host address',1),(6,'start_portbase','8000','Starting portbase',2),(7,'nextport_method','low','Next port method',2),(8,'auto_start','on','Start on creation',2),(9,'ices_path','/usr/bin/ices','Path to Icecast binary',3),(10,'media_path','/path/to/media','Path to MP3 files',3),(11,'mrtg','off','MRTG statistics',4),(12,'mrtg_interval','5','MRTG update interval (minutes)',4);
/*!40000 ALTER TABLE `config` ENABLE KEYS */;
UNLOCK TABLES;


--
-- Table structure for table `config_groups`
--
DROP TABLE IF EXISTS `config_groups`;
CREATE TABLE `config_groups` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL,
  `title` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Data for table `config_groups`
--

LOCK TABLES `config_groups` WRITE;
/*!40000 ALTER TABLE `config_groups` DISABLE KEYS */;
 INSERT INTO `config_groups` VALUES (1,'General','General settings'),(2,'Server','Stream server settings'),(3,'AutoDJ','AutoDJ and media settings'),(4,'Integration','Integration settings'),(5,'Misc','Misc. settings');
/*!40000 ALTER TABLE `config_groups` ENABLE KEYS */;
UNLOCK TABLES;

DROP TABLE IF EXISTS `config_sets`;
CREATE TABLE `config_sets` (
  `id` int(11) NOT NULL auto_increment,
  `configid` int(11) NOT NULL,
  `value` varchar(255) NOT NULL,
  `caption` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

LOCK TABLES `config_sets` WRITE;
/*!40000 ALTER TABLE `config_sets` DISABLE KEYS */;
 INSERT INTO `config_sets` VALUES (1,7,'high','Higher than last port used'),(2,7,'low','Lowest vacant port available'),(3,8,'on','Enabled'),(4,8,'off','Disabled'),(5,11,'on','Enabled'),(6,11,'off','Disabled');
/*!40000 ALTER TABLE `config_sets` ENABLE KEYS */;
UNLOCK TABLES;

